#include "siruri.h"
#include "Exceptii.h"
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>


using namespace std;

namespace Calculator
{
    namespace Calcule
    {

        Sir::Sir()
        {
            _count = 0;
        }
        Sir::~Sir()
        {

        }
    Uint Sir::operator [] (Uint index) const
        {
            if (index < 0 || index >= _count)
            {
                throw ParametruInAfaraIntervalului();
            }
            return _elemente[index];
        }
    Sir& Sir::operator () (Uint count)
    {
        _count = count;
        CalculeazaValori(count);
        return *this;
    }
    ostream& operator << (ostream &out, const Sir &src)
	{
		const int INDEX_W = 4;
		const int VAL_W = 12;

		out << "Index\tValoare" << "\n" ;
		out << "-------------------\n";
		for(int i =0; i  < src._count; ++i)
		{
			out << setw(INDEX_W) << i << setw(VAL_W) << src[i] << "\n";
		}

		return out;
	}

    void Fibonacci::CalculeazaValori(Uint count)
    {
        if(count > MAX_FIB)
        {
            throw ParametruInAfaraIntervalului();
        }
        if (_elemente.size() == 0)
            {
                _elemente.push_back(0);
                _elemente.push_back(1);
            }

            for (Uint i = _elemente.size(); i < _count; i++)
            {
                _elemente.push_back(_elemente[i - 1] + _elemente[i - 2]);
            }
    }

    void Lucas::CalculeazaValori(Uint count)
    {
       if(count > MAX_LUCAS)
       {
           throw ParametruInAfaraIntervalului();
       }
       if(_elemente.size() == 0)
       {
           _elemente.push_back(2);
           _elemente.push_back(1);
       }
       for(Uint i = _elemente.size(); i < _count; i++)
       {
           _elemente.push_back(_elemente[i - 1] + _elemente[i - 2]);
       }
    }


    void Pell::CalculeazaValori(Uint count)
    {
        if(count > MAX_PELL)
        {
            throw ParametruInAfaraIntervalului();
        }
        if(_elemente.size() == 0)
        {
            _elemente.push_back(0);
            _elemente.push_back(1);
        }
        for(Uint i = _elemente.size(); i < _count; i++)
        {
            _elemente.push_back(2 * _elemente[i - 1] + _elemente[i - 2]);
        }
    }

    void Triangular::CalculeazaValori(Uint count)
    {
        if(count > MAX_TRIANGULAR)
        {
            throw ParametruInAfaraIntervalului();
        }
        for(Uint i = _elemente.size(); i < _count; i++)
        {
            _elemente.push_back((i * (i + 1))/2);
        }
    }

    void Pentagonal::CalculeazaValori(Uint count)
    {
        if(count > MAX_PENTAGONAL)
        {
            throw ParametruInAfaraIntervalului();
        }
        for(Uint i = _elemente.size(); i < count; i++)
        {
            _elemente.push_back(i * (3 * i - 1) / 2);
        }

    }



    }

}
