#ifndef SIRURI_H
#define SIRURI_H
#include <iostream>
#include <vector>
using namespace std;

namespace Calculator
{
    namespace Calcule
    {
    typedef unsigned int Uint;
    typedef vector<Uint> TVint;
    typedef vector<Uint>::const_iterator TIterator;

    class Sir
    {
    protected:
        Uint _count;
        TVint _elemente;
        virtual void CalculeazaValori(Uint count) = 0;
    public:
        Sir();
        virtual ~Sir();
        Uint operator [] (Uint index) const;
        Sir& operator () (Uint count);
        friend ostream& operator << (ostream &out, const Sir &sir);
    };

    class Fibonacci: public Sir
    {
    protected:
        void CalculeazaValori(Uint count);
    public:
        enum { MAX_FIB = 48 };
    };

    class Lucas : public Sir
    {
    protected:
        void CalculeazaValori(Uint count);
    public:
        enum { MAX_LUCAS = 47 };
    };

    class Pell : public Sir
    {
    protected:
        void CalculeazaValori(Uint count);
    public:
        enum { MAX_PELL = 27 };
    };

    class Triangular : public Sir
    {
    protected:
        void CalculeazaValori(Uint count);
    public:

        enum { MAX_TRIANGULAR = 1024 };
    };


    class Pentagonal : public Sir
    {
    protected:
        void CalculeazaValori(Uint count);
    public:
        enum { MAX_PENTAGONAL = 1024 };
    };





    }

}



#endif // SIRURI_H
